SetLeverEvent = {};
SetLeverEvent_mt = Class(SetLeverEvent, Event);

InitEventClass(SetLeverEvent, "SetLeverEvent");

function SetLeverEvent:emptyNew()
    local self = Event:new(SetLeverEvent_mt);
    self.className="SetLeverEvent";
    return self;
end;

function SetLeverEvent:new(vehicle, isLever)
    local self = SetLeverEvent:emptyNew()
    self.vehicle = vehicle;
	self.isLever = isLever;
    return self;
end;

function SetLeverEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.isLever = streamReadBool(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function SetLeverEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteBool(streamId, self.isLever);
end;

function SetLeverEvent:run(connection)   
	self.vehicle:setLever(self.isLever, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(SetLeverEvent:new(vehicle, self.isLever), nil, connection, self.vehicle);
    end;
end;

function SetLeverEvent.sendEvent(vehicle, isLever, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(SetLeverEvent:new(vehicle, isLever), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(SetLeverEvent:new(vehicle, isLever));
		end;
	end;
end;